using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using Syncfusion.Windows.Forms.Grid;

namespace PrintTwoGrids
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private Syncfusion.Windows.Forms.Grid.GridControl gridControl1;
		private Syncfusion.Windows.Forms.Grid.GridControl gridControl2;
		private System.Windows.Forms.Button butPrintPreview;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.gridControl1 = new Syncfusion.Windows.Forms.Grid.GridControl();
			this.gridControl2 = new Syncfusion.Windows.Forms.Grid.GridControl();
			this.butPrintPreview = new System.Windows.Forms.Button();
			((System.ComponentModel.ISupportInitialize)(this.gridControl1)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.gridControl2)).BeginInit();
			this.SuspendLayout();
			// 
			// gridControl1
			// 
			this.gridControl1.Dock = System.Windows.Forms.DockStyle.Top;
			this.gridControl1.Location = new System.Drawing.Point(0, 0);
			this.gridControl1.Name = "gridControl1";
			this.gridControl1.Size = new System.Drawing.Size(520, 176);
			this.gridControl1.TabIndex = 0;
			this.gridControl1.Text = "gridControl1";
			// 
			// gridControl2
			// 
			this.gridControl2.Dock = System.Windows.Forms.DockStyle.Top;
			this.gridControl2.Location = new System.Drawing.Point(0, 176);
			this.gridControl2.Name = "gridControl2";
			this.gridControl2.RowCount = 100;
			this.gridControl2.Size = new System.Drawing.Size(520, 168);
			this.gridControl2.TabIndex = 1;
			this.gridControl2.Text = "gridControl2";
			// 
			// butPrintPreview
			// 
			this.butPrintPreview.Location = new System.Drawing.Point(192, 360);
			this.butPrintPreview.Name = "butPrintPreview";
			this.butPrintPreview.Size = new System.Drawing.Size(88, 23);
			this.butPrintPreview.TabIndex = 2;
			this.butPrintPreview.Text = "Print Preview";
			this.butPrintPreview.Click += new System.EventHandler(this.butPrintPreview_Click);
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(520, 389);
			this.Controls.Add(this.butPrintPreview);
			this.Controls.Add(this.gridControl2);
			this.Controls.Add(this.gridControl1);
			this.Name = "Form1";
			this.Text = "Form1";
			((System.ComponentModel.ISupportInitialize)(this.gridControl1)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.gridControl2)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		private void butPrintPreview_Click(object sender, System.EventArgs e)
		{
			MyGridPrintDocument pd = new MyGridPrintDocument(this.gridControl1, this.gridControl2, true);
			PrintPreviewDialog dlg = new PrintPreviewDialog();
			dlg.Document = pd;
			dlg.ShowDialog();
		}
	}
	public class MyGridPrintDocument : GridPrintDocument
	{
		private GridControlBase grid1;
		private GridControlBase grid2;
		private bool m_bHasMorePages;

		public MyGridPrintDocument(GridControlBase grid1, GridControlBase grid2, bool printPreview) : base(grid1, printPreview)
		{
			this.grid1 = grid1;
			this.grid2 = grid2;
		}

		protected override void OnPrintPage(System.Drawing.Printing.PrintPageEventArgs ev)
		{
			//don not call baseclass...

			if(this.m_bHasMorePages)
			{
				//set where you want the second grid displayed...
				int width = grid2.Model.ColWidths.GetTotal(0, grid1.Model.ColCount);
				int height = grid2.Model.RowHeights.GetTotal(0, grid1.Model.RowCount);
				Rectangle botGridRect = new Rectangle(ev.MarginBounds.Left, ev.PageBounds.Height/2, width, height);
				grid2.DrawGrid(ev.Graphics, botGridRect, false);
				//botGridRect.Inflate(1,1);
				ev.Graphics.DrawRectangle(Pens.Black, botGridRect);
				this.m_bHasMorePages = false;
			}
			else
			{
				int gridLoc = 0;
				//set where you want the grid displayed...
				int width = grid1.Model.ColWidths.GetTotal(0, grid1.Model.ColCount);
				int height = grid1.Model.RowHeights.GetTotal(0, grid1.Model.RowCount);
				Rectangle topGridRect = new Rectangle(ev.MarginBounds.Left, ev.MarginBounds.Top, width, height);
				grid1.DrawGrid(ev.Graphics, topGridRect, false);
				//topGridRect.Inflate(1,1);
				ev.Graphics.DrawRectangle(Pens.Black, topGridRect);
				gridLoc = height;

				//set where you want the second grid displayed...
				width = grid2.Model.ColWidths.GetTotal(0, grid1.Model.ColCount);
				height = grid2.Model.RowHeights.GetTotal(0, grid1.Model.RowCount);
				Rectangle botGridRect = new Rectangle(ev.MarginBounds.Left, ev.PageBounds.Height/2, width, height);
				grid2.DrawGrid(ev.Graphics, botGridRect, false);
				//botGridRect.Inflate(1,1);
				ev.Graphics.DrawRectangle(Pens.Black, botGridRect);
				gridLoc += height;
				if(gridLoc > ev.MarginBounds.Height)
				{
					ev.HasMorePages = true;
					this.m_bHasMorePages = true;
				}
			}
		}
	}
}
